package com.example.repeater;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.ToggleButton;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;
import java.util.ArrayList;
import java.util.HashMap;

public class MainActivity extends AppCompatActivity {
    private ArrayList<HashMap<String,String>> Data = new ArrayList<HashMap<String, String>>();
    private HashMap<String,String> InputData1 = new HashMap<>();
    private HashMap<String,String> InputData2 = new HashMap<>();
    private HashMap<String,String> InputData3 = new HashMap<>();
    private HashMap<String,String> InputData4 = new HashMap<>();
    private HashMap<String,String> InputData5 = new HashMap<>();
    private HashMap<String,String> InputData6 = new HashMap<>();
    private HashMap<String,String> InputData7 = new HashMap<>();
    private HashMap<String,String> InputData8 = new HashMap<>();
    private HashMap<String,String> InputData9 = new HashMap<>();
    private HashMap<String,String> InputData10 = new HashMap<>();
    private HashMap<String,String> InputData11 = new HashMap<>();
    private HashMap<String,String> InputData12 = new HashMap<>();
    private ListView listview_info;
    private ListView listview_rf;
    static final String[] LIST_MENU = {"LIST1", "LIST2", "LIST3"} ;
    /*** WIFI Start***/
    BufferedReader in;      //서버로부터 온 데이터를 읽는다.
    PrintWriter out;        //서버에 데이터를 전송한다.
    TextView input;
    TextView output;
    String data;
    ToggleButton button;
    private Socket socket;  //소켓생성
    /*** WIFI END***/
    private ArrayList<ListViewItem> listViewItemList = new ArrayList<ListViewItem>() ;


    ImageButton imageButton01;
    ImageButton imageButton02;
    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);


        imageButton01 = findViewById(R.id.imageButton01);
        imageButton02 = findViewById(R.id.imageButton02);
        listview_info = findViewById(R.id.listview_info);
        listview_rf = findViewById(R.id.listview_rf);
        imageButton02 = findViewById(R.id.imageButton02);

        input = findViewById(R.id.input);
        output = findViewById(R.id.output);
        button = findViewById(R.id.button);

        ListView listview ;
        ListViewAdapter adapter_infor;
        ListViewAdapter adapter_rf;


        // Adapter 생성
        adapter_infor = new ListViewAdapter() ;
        adapter_rf = new ListViewAdapter();
        // 리스트뷰 참조 및 Adapter달기
        listview = (ListView) findViewById(R.id.listview_info);
        listview.setAdapter(adapter_infor);


        adapter_infor.addItem("firm info.","0.1Ver");
        adapter_infor.addItem("FPGA Ver.","0.2Ver");
        adapter_infor.addItem("F/W Ver.","0.3Ver");
        adapter_infor.addItem("Config No.","0.4Ver");
        adapter_infor.addItem("Sub Frame No.","0.5Ver");
        adapter_infor.addItem("CH1 TTG","0.6Ver");
        adapter_infor.addItem("CH1 RTG","0.7Ver");
        adapter_infor.addItem("CH2 TTG","0.8Ver");
        adapter_infor.addItem("CH2 RTG","0.9Ver");
        adapter_infor.addItem("CH2 Polarity","1.1Ver");
        adapter_infor.addItem("CH2 Default","1.2Ver");
        adapter_infor.addItem("Auto Config","1.3Ver");

        listview = (ListView) findViewById(R.id.listview_rf);
        listview.setAdapter(adapter_rf);
        adapter_rf.addItem("input ATT","0.1Ver");
        adapter_rf.addItem("Output ATT","0.2Ver");
        adapter_rf.addItem("Input Offset ATT","0.3Ver");
        adapter_rf.addItem("Output Offset ATT","0.4Ver");
        adapter_rf.addItem("Gain(dB)","0.5Ver");
        adapter_rf.addItem("ALC Level","0.6Ver");
        adapter_rf.addItem("PA Enable","0.7Ver");
        adapter_rf.addItem("EX PA Enable","0.8Ver");
        adapter_rf.addItem("RF PLL Freq","0.9Ver");
        adapter_rf.addItem("AGD Level","1.1Ver");
        adapter_rf.addItem("ISO Level","1.2Ver");
        adapter_rf.addItem("Temperature","1.3Ver");
/*


        listview_info =(ListView)findViewById(R.id.listview_info);

        //데이터 초기화
        InputData1.put("fw_info","firm info.");
        Data.add(InputData1);
        InputData2.put("fw_info","FPGA Ver.");
        Data.add(InputData2);
        InputData3.put("fw_info","F/W Ver.");
        Data.add(InputData3);
        InputData4.put("fw_info","Config No.");
        Data.add(InputData4);
        InputData5.put("fw_info","Sub Frame No.");
        Data.add(InputData5);
        InputData6.put("fw_info","CH1 TTG");
        Data.add(InputData6);
        InputData7.put("fw_info","CH1 RTG");
        Data.add(InputData7);
        InputData8.put("fw_info","CH2 TTG");
        Data.add(InputData8);
        InputData9.put("fw_info","CH2 RTG");
        Data.add(InputData9);
        InputData10.put("fw_info","CH2 Polarity");
        Data.add(InputData10);
        InputData11.put("fw_info","CH2 Default");
        Data.add(InputData11);
        InputData12.put("fw_info","Auto Config");
        Data.add(InputData12);

        //simpleAdapter 생성
        SimpleAdapter simpleAdapter = new SimpleAdapter(this,Data,android.R.layout.simple_list_item_2,new String[]{"fw_info"},new int[]{android.R.id.text1});
        listview_info.setAdapter(simpleAdapter);
//        ArrayAdapter adapter = new ArrayAdapter(this, android.R.layout.simple_list_item_2, LIST_MENU) ;
//        listview_info.setAdapter(adapter);
*/
// 버튼을 누르는 이벤트 발생, 이벤트 제어문이기 때문에 이벤트 발생 때마다 발동된다. 시스템이 처리하는 부분이 무한루프문에
//있더라도 이벤트가 발생하면 자동으로 실행된다.
        button.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                new Thread() {
                    public void run() {
                        String data = input.getText().toString(); //글자입력칸에 있는 글자를 String 형태로 받아서 data에 저장
                        Log.w("NETWORK", " " + data);
                        if (data != null) { //만약 데이타가 아무것도 입력된 것이 아니라면
                            out.println(data); //data를 stream 형태로 변형하여 전송. 변환내용은 쓰레드에 담겨 있다.

                        }
                    }
                }.start();

            }
        });

        Thread worker = new Thread() {    //worker 를 Thread 로 생성
            public void run() { //스레드 실행구문
                try {
//소켓을 생성하고 입출력 스트립을 소켓에 연결한다.
                    SocketAddress remoteAddr=new InetSocketAddress("192.168.10.4",4000);
                    Socket socket=new Socket();
                    socket.connect(remoteAddr); //remoteAddr
//                    br = new BufferedReader(new InputStreamReader(socket.getInputStream()));
//                    out=new BufferedOutputStream(socket.getOutputStream()); //output stream
                    in=new BufferedReader(new InputStreamReader(socket.getInputStream(),"EUC_KR")); //input stream
//                    socket = new Socket("192.168.2.38", 9999); //소켓생성
                    out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(socket.getOutputStream(),"EUC_KR")),true);




//                    out = new PrintWriter(socket.getOutputStream(), true); //데이터를 전송시 stream 형태로 변환하여                                                                                                                       //전송한다.
//                    in = new BufferedReader(new InputStreamReader(
//                            socket.getInputStream())); //데이터 수신시 stream을 받아들인다.
                    Log.w("NETWORK4", "set Complete " + data);
                } catch (IOException e) {
                    e.printStackTrace();
                }

//소켓에서 데이터를 읽어서 화면에 표시한다.
                try {
                    while (true) {
                        data = in.readLine(); // in으로 받은 데이타를 String 형태로 읽어 data 에 저장
                        output.post(new Runnable() {
                            public void run() {
                                Log.w("NETWORK2", " " + data);
                                output.setText(data); //글자출력칸에 서버가 보낸 메시지를 받는다.
                            }
                        });
                    }
                } catch (Exception e) {
                    Log.w("NETWORK3", "Error Occur!! " + data);
                }
            }
        };
        worker.start();  //onResume()에서 실행.




    }
    @Override
    protected void onStop() {  //앱 종료시
        super.onStop();
        try {
            socket.close(); //소켓을 닫는다.
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    public void onClick(View view) {
        switch(view.getId()) {
            case R.id.imageButton01:
                listview_info.setVisibility(view.VISIBLE);
                listview_rf.setVisibility(view.INVISIBLE);
                break;
            case R.id.imageButton02:
                listview_info.setVisibility(view.INVISIBLE);
                listview_rf.setVisibility(view.VISIBLE);
                break;
        }
    }
}
